#! /usr/bin/env python
# encoding: utf-8

""" A tool to build QT3 ui files into python code """
import Object, Action, Utils, os

class pyuic(Object.genobj):
	def __init__(self, type="pyuic"):
		Object.genobj.__init__(self,type)
	def get_valid_types(self):
		return ['pyuic']
	def apply(self):
		filename=self.source
		node = self.m_current_path.find_node( filename.split(os.sep) )
		base, ext = os.path.splitext(filename)
		task = self.create_task('pyuic', nice=4)
		task.set_inputs(node)
		task.set_outputs(node.change_ext('.py'))
	def install(self):
		#filename=dir(self)
		for task in self.m_tasks:
			self.install_results('PYUIC_INST', '',task )

def setup(env):
	pyuic_str = '${PYUIC} -o ${TGT} ${PYUIC_FLAGS} ${SRC[0].abspath()}'
	Action.simple_action('pyuic', pyuic_str, color="BLUE")
	Object.register('pyuic', pyuic)
		
def detect(conf):
	e = conf.create_program_enumerator()
	e.mandatory = 1
	e.name = 'pyuic'
	pyuic = e.run()
	if not pyuic: return 0
	conf.env['PYUIC'] = pyuic
	conf.env['PYUIC_INST'] = os.sep.join([conf.env['PREFIX'],'share',Utils.g_module.APPNAME, 'app_module'])
	return 1
